<bugID>1007979<Summary>refactor nsSearchSuggestions to use a reusable JSM</Summary><Description>Created attachment 8419782
newSuggestAPI

To avoid duplicating a bunch of this code in order to fix bug 612453 (and a future, similar bug for the new about:newtab implementation), we should have a single implementation for returning a mix of local and remote suggestions for various consumers and UIs.

First part of this bug is creating a new SearchSuggest.jsm containing all of the logic.

As a note, I've simplified the backoff behaviour substantially (the old logic was... weird).  This isn't quite exponential backoff, but we can discuss it (it's pretty isolated from the rest of the JSM, so we can tweak it as a followup).  I've also trimmed out a bunch of cruft, and made a bunch of pseudo-consts into real consts to make it obvious what's going on.</Description></bugID>